=== debian/control ===
Source: ros-iron-mapviz-plugins
Section: misc
Priority: optional
Maintainer: Southwest Research Institute <swri-robotics@swri.org>
Build-Depends: debhelper (>= 9.0.0), libqt5core5a, libqt5opengl5-dev, qt5-qmake, ros-iron-ament-cmake, ros-iron-ament-index-cpp, ros-iron-cv-bridge, ros-iron-gps-msgs, ros-iron-image-transport, ros-iron-map-msgs, ros-iron-mapviz, ros-iron-marti-common-msgs, ros-iron-marti-nav-msgs, ros-iron-marti-sensor-msgs, ros-iron-marti-visualization-msgs, ros-iron-nav-msgs, ros-iron-pluginlib, ros-iron-rclcpp, ros-iron-rclcpp-action, ros-iron-ros-environment, ros-iron-sensor-msgs, ros-iron-std-msgs, ros-iron-stereo-msgs, ros-iron-swri-image-util, ros-iron-swri-math-util, ros-iron-swri-route-util, ros-iron-swri-transform-util, ros-iron-tf2, ros-iron-visualization-msgs, ros-iron-ros-workspace
Homepage: https://github.com/swri-robotics/mapviz
Standards-Version: 3.9.2

Package: ros-iron-mapviz-plugins
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt5core5a, libqt5opengl5, ros-iron-ament-index-cpp, ros-iron-cv-bridge, ros-iron-gps-msgs, ros-iron-image-transport, ros-iron-map-msgs, ros-iron-mapviz, ros-iron-marti-common-msgs, ros-iron-marti-nav-msgs, ros-iron-marti-sensor-msgs, ros-iron-marti-visualization-msgs, ros-iron-nav-msgs, ros-iron-pluginlib, ros-iron-rclcpp, ros-iron-rclcpp-action, ros-iron-sensor-msgs, ros-iron-std-msgs, ros-iron-stereo-msgs, ros-iron-swri-image-util, ros-iron-swri-math-util, ros-iron-swri-route-util, ros-iron-swri-transform-util, ros-iron-tf2, ros-iron-visualization-msgs, ros-iron-ros-workspace
Description: Common plugins for the Mapviz visualization tool
